-------------------------------------------------------------------------------------
-- FILE NAME : toplevel_template.vhd
-- AUTHOR    : Luis
-- COMPANY   : 
-- UNITS     : Entity       - toplevel_template
--             Architecture - Behavioral
-- LANGUAGE  : VHDL
-- DATE      : May 21, 2010
-------------------------------------------------------------------------------------
--
-------------------------------------------------------------------------------------
-- DESCRIPTION
-- ===========
-- This entity is template for writing test benches
-- 
--
-------------------------------------------------------------------------------------
 
-------------------------------------------------------------------------------------
-- LIBRARIES
-------------------------------------------------------------------------------------
library ieee;
    use ieee.std_logic_1164.all;
    -- IEEE  
    --use ieee.numeric_std.all; 
    -- non-IEEE 
    use ieee.std_logic_unsigned.all;
    use ieee.std_logic_misc.all;
    use ieee.std_logic_arith.all; 

library UNISIM;
use UNISIM.VComponents.all;

Library xil_defaultlib;
-------------------------------------------------------------------------------------
-- ENTITY
-------------------------------------------------------------------------------------
entity axi_fmc110_synth is
port (
    SYS_CLK_P           : in std_logic;
    SYS_CLK_N           : in std_logic;

--STAR sip_fmc110, ID=0 (ext_fmc110)
   FMC_TO_CPLD_0                           : inout std_logic_vector(3 downto 0);
   FRONT_IO_FMC_0                          : inout std_logic_vector(3 downto 0);
   CLK_TO_FPGA_P_0                         : in    std_logic;
   CLK_TO_FPGA_N_0                         : in    std_logic;
   EXT_TRIGGER_P_0                         : in    std_logic;
   EXT_TRIGGER_N_0                         : in    std_logic;
   SYNC_FROM_FPGA_P_0                      : out   std_logic;
   SYNC_FROM_FPGA_N_0                      : out   std_logic;
   DAC_SYNC_P_0                            : out   std_logic;
   DAC_SYNC_N_0                            : out   std_logic;
   DAC0_DATA_P_0                           : out   std_logic_vector(15 downto 0);
   DAC0_DATA_N_0                           : out   std_logic_vector(15 downto 0);
   DAC0_DCLK_P_0                           : out   std_logic;
   DAC0_DCLK_N_0                           : out   std_logic;
   DAC1_DATA_P_0                           : out   std_logic_vector(15 downto 0);
   DAC1_DATA_N_0                           : out   std_logic_vector(15 downto 0);
   DAC1_DCLK_P_0                           : out   std_logic;
   DAC1_DCLK_N_0                           : out   std_logic;
   ADC0_DA_P_0                             : in    std_logic_vector(11 downto 0);
   ADC0_DA_N_0                             : in    std_logic_vector(11 downto 0);
   ADC0_OVRA_P_0                           : in    std_logic;
   ADC0_OVRA_N_0                           : in    std_logic;
   ADC0_DB_P_0                             : in    std_logic_vector(11 downto 0);
   ADC0_DB_N_0                             : in    std_logic_vector(11 downto 0);
   ADC0_OVRB_P_0                           : in    std_logic;
   ADC0_OVRB_N_0                           : in    std_logic;
   ADC0_CLKA_P_0                           : in    std_logic;
   ADC0_CLKA_N_0                           : in    std_logic;
   ADC1_DA_P_0                             : in    std_logic_vector(11 downto 0);
   ADC1_DA_N_0                             : in    std_logic_vector(11 downto 0);
   ADC1_OVRA_P_0                           : in    std_logic;
   ADC1_OVRA_N_0                           : in    std_logic;
   ADC1_CLKA_P_0                           : in    std_logic;
   ADC1_CLKA_N_0                           : in    std_logic;
   PG_M2C_0                                : in    std_logic;
   PRSNT_M2C_L_0                           : in    std_logic

);
end axi_fmc110_synth;

-------------------------------------------------------------------------------------
-- ARCHITECTURE
-------------------------------------------------------------------------------------
architecture Behavioral of axi_fmc110_synth is

-------------------------------------------------------------------------------------
-- CONSTANTS
-------------------------------------------------------------------------------------
COMPONENT axi_traffic_gen_4
  PORT (
    s_axi_aclk : IN STD_LOGIC;
    s_axi_aresetn : IN STD_LOGIC;
    m_axi_lite_ch1_awaddr : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_lite_ch1_awprot : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    m_axi_lite_ch1_awvalid : OUT STD_LOGIC;
    m_axi_lite_ch1_awready : IN STD_LOGIC;
    m_axi_lite_ch1_wdata : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_lite_ch1_wstrb : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    m_axi_lite_ch1_wvalid : OUT STD_LOGIC;
    m_axi_lite_ch1_wready : IN STD_LOGIC;
    m_axi_lite_ch1_bresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    m_axi_lite_ch1_bvalid : IN STD_LOGIC;
    m_axi_lite_ch1_bready : OUT STD_LOGIC;
    m_axi_lite_ch1_araddr : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_lite_ch1_arvalid : OUT STD_LOGIC;
    m_axi_lite_ch1_arready : IN STD_LOGIC;
    m_axi_lite_ch1_rdata : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_lite_ch1_rvalid : IN STD_LOGIC;
    m_axi_lite_ch1_rresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    m_axi_lite_ch1_rready : OUT STD_LOGIC;
    done : OUT STD_LOGIC;
    status : OUT STD_LOGIC_VECTOR(31 DOWNTO 0)
  );
END COMPONENT;
ATTRIBUTE SYN_BLACK_BOX : BOOLEAN;
ATTRIBUTE SYN_BLACK_BOX OF axi_traffic_gen_4 : COMPONENT IS TRUE;
ATTRIBUTE BLACK_BOX_PAD_PIN : STRING;
ATTRIBUTE BLACK_BOX_PAD_PIN OF axi_traffic_gen_4 : COMPONENT IS "s_axi_aclk,s_axi_aresetn,m_axi_lite_ch1_awaddr[31:0],m_axi_lite_ch1_awprot[2:0],m_axi_lite_ch1_awvalid,m_axi_lite_ch1_awready,m_axi_lite_ch1_wdata[31:0],m_axi_lite_ch1_wstrb[3:0],m_axi_lite_ch1_wvalid,m_axi_lite_ch1_wready,m_axi_lite_ch1_bresp[1:0],m_axi_lite_ch1_bvalid,m_axi_lite_ch1_bready,m_axi_lite_ch1_araddr[31:0],m_axi_lite_ch1_arvalid,m_axi_lite_ch1_arready,m_axi_lite_ch1_rdata[31:0],m_axi_lite_ch1_rvalid,m_axi_lite_ch1_rresp[1:0],m_axi_lite_ch1_rready,done,status[31:0]";



COMPONENT vio_0
  PORT (
    clk : IN STD_LOGIC;
    probe_in0 : IN STD_LOGIC_VECTOR(7 DOWNTO 0);
    probe_out0 : OUT STD_LOGIC_VECTOR(1 DOWNTO 0)
  );
END COMPONENT;
ATTRIBUTE SYN_BLACK_BOX OF vio_0 : COMPONENT IS TRUE;
ATTRIBUTE BLACK_BOX_PAD_PIN OF vio_0 : COMPONENT IS "clk,probe_in0[7:0],probe_out0[1:0]";


COMPONENT ila_0
  PORT (
    clk : IN STD_LOGIC;
    probe0 : IN STD_LOGIC_VECTOR(127 DOWNTO 0)
  );
END COMPONENT;
ATTRIBUTE SYN_BLACK_BOX OF ila_0 : COMPONENT IS TRUE;
ATTRIBUTE BLACK_BOX_PAD_PIN OF ila_0 : COMPONENT IS "clk,probe0[127:0]";


COMPONENT jtag_axi_0
  PORT (
    aclk : IN STD_LOGIC;
    aresetn : IN STD_LOGIC;
    m_axi_awaddr : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_awprot : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    m_axi_awvalid : OUT STD_LOGIC;
    m_axi_awready : IN STD_LOGIC;
    m_axi_wdata : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_wstrb : OUT STD_LOGIC_VECTOR(3 DOWNTO 0);
    m_axi_wvalid : OUT STD_LOGIC;
    m_axi_wready : IN STD_LOGIC;
    m_axi_bresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    m_axi_bvalid : IN STD_LOGIC;
    m_axi_bready : OUT STD_LOGIC;
    m_axi_araddr : OUT STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_arprot : OUT STD_LOGIC_VECTOR(2 DOWNTO 0);
    m_axi_arvalid : OUT STD_LOGIC;
    m_axi_arready : IN STD_LOGIC;
    m_axi_rdata : IN STD_LOGIC_VECTOR(31 DOWNTO 0);
    m_axi_rresp : IN STD_LOGIC_VECTOR(1 DOWNTO 0);
    m_axi_rvalid : IN STD_LOGIC;
    m_axi_rready : OUT STD_LOGIC
  );
END COMPONENT;
ATTRIBUTE SYN_BLACK_BOX OF jtag_axi_0 : COMPONENT IS TRUE;
ATTRIBUTE BLACK_BOX_PAD_PIN OF jtag_axi_0 : COMPONENT IS "aclk,aresetn,m_axi_awaddr[31:0],m_axi_awprot[2:0],m_axi_awvalid,m_axi_awready,m_axi_wdata[31:0],m_axi_wstrb[3:0],m_axi_wvalid,m_axi_wready,m_axi_bresp[1:0],m_axi_bvalid,m_axi_bready,m_axi_araddr[31:0],m_axi_arprot[2:0],m_axi_arvalid,m_axi_arready,m_axi_rdata[31:0],m_axi_rresp[1:0],m_axi_rvalid,m_axi_rready";


-----------------------------------------------------------------------------------
-- SIGNALS
-----------------------------------------------------------------------------------
signal clk       : std_logic;
signal sys_clk_i : std_logic;

signal rst       : std_logic;

signal ila_probe : std_logic_vector(127 downto 0);
signal vbutton  : std_logic_vector(1 downto 0);
signal vled     : std_logic_vector(7 downto 0);

signal axi_aclk     : std_logic;
signal axi_aresetn  : std_logic;



signal dac0_tdata             : std_logic_vector(31 downto 0); 
signal dac0_tkeep             : std_logic_vector(3 downto 0); 
signal dac0_tlast             : std_logic; 
signal dac0_tready            : std_logic;
signal dac0_tstrb             : std_logic;
signal dac0_tuser             : std_logic_vector(31 downto 0);
signal dac0_tvalid            : std_logic;

signal adc0_tdata             : std_logic_vector(31 downto 0); 
signal adc0_tkeep             : std_logic_vector(3 downto 0); 
signal adc0_tlast             : std_logic; 
signal adc0_tready            : std_logic;
signal adc0_tstrb             : std_logic;
signal adc0_tuser             : std_logic_vector(31 downto 0);
signal adc0_tvalid            : std_logic;


signal dac0_enable            : std_logic;

signal cmdclk_out  : std_logic;
signal cmd_in      : std_logic_vector(63 downto 0);
signal cmd_in_val  : std_logic;
signal cmd_out     : std_logic_vector(63 downto 0);
signal cmd_out_val : std_logic;


--AXI-Lite to 4DSP Stellar Cmds Signals
signal axi_awaddr            : std_logic_vector(32-1 downto 0);
signal axi_awvalid           : std_logic;
signal axi_awready           : std_logic;
signal axi_wdata             : std_logic_vector(31  downto 0);                        
signal axi_wstrb             : std_logic_vector(3  downto 0);                        
signal axi_wvalid            : std_logic;
signal axi_wready            : std_logic;
signal axi_bresp             : std_logic_vector(1 downto 0);
signal axi_bvalid            : std_logic;
signal axi_bready            : std_logic;
signal axi_araddr            : std_logic_vector(31  downto 0);                                 
signal axi_arvalid           : std_logic;
signal axi_arready           : std_logic;
signal axi_rdata             : std_logic_vector(31 downto 0);
signal axi_rresp             : std_logic_vector(1 downto 0);
signal axi_rvalid            : std_logic;
signal axi_rready            : std_logic;





-- Traffic Generator Signals
signal done :  std_logic;
signal status : std_logic_vector(31 DOWNTO 0);



signal rstn : std_logic;




signal clk200 : std_logic;
signal clk125 : std_logic;
signal pll_lock : std_logic;


--***********************************************************************************
begin
--**********************************************************************************


-----------------------------------------------------------------------------------
-- Clock & reset generation
-----------------------------------------------------------------------------------
--   inst_ibufds0: IBUFDS
--  -- generic map (
--   --   DIFF_TERM => FALSE, -- Differential Termination 
--    --  IBUF_LOW_PWR => TRUE, -- Low power (TRUE) vs. performance (FALSE) setting for referenced I/O standards
--     -- IOSTANDARD => "DEFAULT")
--   port map (
--      O => sys_clk_i,  -- Buffer output
--      I => sys_clk_p,  -- Diff_p buffer input (connect directly to top-level port)
--      IB => sys_clk_n -- Diff_n buffer input (connect directly to top-level port)
--   );
--
--  inst_bug0: BUFG
--   port map (
--      O => clk, -- 1-bit output: Clock output
--      I => sys_clk_i  -- 1-bit input: Clock input
--   );


axi_aclk    <= clk;
axi_aresetn <= rstn;

brd_clocks_inst: 
entity xil_defaultlib.brd_clocks
port map (
  rst             => '0',
  sysclk_p        => sys_clk_p,
  sysclk_n        => sys_clk_n,
  pll_lock        => pll_lock,
  clk50           => open,
  clk125          => clk125,
  clk200          => clk200
);


clk <= clk125;

-- IDELAYCTRL
idelayctrl_inst : idelayctrl
port map (
  rst    => '0', --vbutton(0)
  refclk => clk200,
  rdy    => open
);

-----------------------------------------------------------------------------------
-- Xilinx Logic Analyzer
----------------------------------------------------------------------------------

inst0_ila_0: 
ila_0
  PORT MAP (
    clk     => clk,
    probe0  => ila_probe 
  );


ila_probe(31 downto 0) <= adc0_tdata;
ila_probe(32) <= adc0_tvalid;
ila_probe(33) <= dac0_enable;

ila_probe(127 downto 34) <= (others=>'0');

inst0_vio_0: 
vio_0
  PORT MAP (
    clk         => clk,
    probe_in0   => vled, 
    probe_out0  => vbutton 
  );


process(clk)
begin
    if rising_edge(clk) then
        rstn <= not vbutton(0);
    end if;
end process;


vled(0) <= rstn;
vled(1) <= vbutton(1);
vled(2) <= '1'; -- done;
vled(7 downto 3) <= (others=>'1');--status(4 downto 0);


--------------------------------------------------------------------------------------
-- AXI_FMC110 IP
---------------------------------------------------------------------------------------
inst_axi_fmc110:
entity xil_defaultlib.axi_fmc110
port map (
   s_axi_aclk       =>  axi_aclk,
   s_axi_aresetn    =>  axi_aresetn,
   -- axi-lite command interface
   s_axi_awaddr     =>  axi_awaddr,
   s_axi_awvalid    =>  axi_awvalid,
   s_axi_awready    =>  axi_awready,
   s_axi_wdata      =>  axi_wdata,
   s_axi_wstrb      =>  axi_wstrb,
   s_axi_wvalid     =>  axi_wvalid,
   s_axi_wready     =>  axi_wready,
   s_axi_bresp      =>  axi_bresp,
   s_axi_bvalid     =>  axi_bvalid,
   s_axi_bready     =>  axi_bready,
   s_axi_araddr     =>  axi_araddr,
   s_axi_arvalid    =>  axi_arvalid,
   s_axi_arready    =>  axi_arready,
   s_axi_rdata      =>  axi_rdata,
   s_axi_rresp      =>  axi_rresp,
   s_axi_rvalid     =>  axi_rvalid,
   s_axi_rready     =>  axi_rready,
   -- axi-stream slave interface for DAC0
   dac0_tdata       => dac0_tdata,
   dac0_tkeep       => dac0_tkeep,     
   dac0_tlast       => dac0_tlast,     
   dac0_tready      => dac0_tready,    
   dac0_tstrb       => dac0_tstrb,     
   dac0_tuser       => dac0_tuser,     
   dac0_tvalid      => dac0_tvalid,  
   -- axi-stream master interface for ADC0
   adc0_tdata       => adc0_tdata,  
   adc0_tkeep       => adc0_tkeep,  
   adc0_tlast       => adc0_tlast,  
   adc0_tready      => adc0_tready,  
   adc0_tstrb       => adc0_tstrb,  
   adc0_tuser       => adc0_tuser,  
   adc0_tvalid      => adc0_tvalid,  
   -- Fmc110 External Signals
   fmc_to_cpld               =>   fmc_to_cpld_0,
   front_io_fmc              =>   front_io_fmc_0,
   clk_to_fpga_p             =>   clk_to_fpga_p_0,
   clk_to_fpga_n             =>   clk_to_fpga_n_0,
   ext_trigger_p             =>   ext_trigger_p_0,
   ext_trigger_n             =>   ext_trigger_n_0,
   sync_from_fpga_p          =>   sync_from_fpga_p_0,
   sync_from_fpga_n          =>   sync_from_fpga_n_0,
   dac_sync_p                =>   dac_sync_p_0,
   dac_sync_n                =>   dac_sync_n_0,
   dac0_data_p               =>   dac0_data_p_0,
   dac0_data_n               =>   dac0_data_n_0,
   dac0_dclk_p               =>   dac0_dclk_p_0,
   dac0_dclk_n               =>   dac0_dclk_n_0,
   dac1_data_p               =>   dac1_data_p_0,
   dac1_data_n               =>   dac1_data_n_0,
   dac1_dclk_p               =>   dac1_dclk_p_0,
   dac1_dclk_n               =>   dac1_dclk_n_0,
   adc0_da_p                 =>   adc0_da_p_0,
   adc0_da_n                 =>   adc0_da_n_0,
   adc0_ovra_p               =>   adc0_ovra_p_0,
   adc0_ovra_n               =>   adc0_ovra_n_0,
   adc0_db_p                 =>   adc0_db_p_0,
   adc0_db_n                 =>   adc0_db_n_0,
   adc0_ovrb_p               =>   adc0_ovrb_p_0,
   adc0_ovrb_n               =>   adc0_ovrb_n_0,
   adc0_clka_p               =>   adc0_clka_p_0,
   adc0_clka_n               =>   adc0_clka_n_0,
   adc1_da_p                 =>   adc1_da_p_0,
   adc1_da_n                 =>   adc1_da_n_0,
   adc1_ovra_p               =>   adc1_ovra_p_0,
   adc1_ovra_n               =>   adc1_ovra_n_0,
   adc1_clka_p               =>   adc1_clka_p_0,
   adc1_clka_n               =>   adc1_clka_n_0,
   pg_m2c                    =>   pg_m2c_0,
   prsnt_m2c_l               =>   prsnt_m2c_l_0   
);

-------------------------------------------------------------------------
-- FMC110 ADC0 Data Recv 
--------------------------------------------------------------------------
-- adc0_tdata,  
-- adc0_tlast,  
adc0_tready  <= '1'; 
adc0_tstrb   <= '0'; 
adc0_tkeep   <= (others=>'0');  
-- adc0_tuser,  
-- adc0_tvalid,



-------------------------------------------------------------------------
-- FMC110 DAC0 Data Generator 
---------------------------------------------------------------------------
inst0_axi_stream_send:
entity xil_defaultlib.axi_stream_send 
port map (
    clk        => axi_aclk,
    rstn       => axi_aresetn,
    tdata      => dac0_tdata,
    tvalid     => dac0_tvalid,
    enable     => dac0_enable 
);


process(clk)
begin
    if rising_edge(clk) then
        if axi_wdata = x"00000008" and axi_awaddr = x"00002404"  and axi_awvalid = '1' and axi_wvalid = '1' then
            dac0_enable <= '1';
        else
            dac0_enable <= '0';
        end if;
    end if;
end process;


--dac0_tkeep 
--dac0_tready
--dac0_tstrb 
dac0_tuser <= (others=>'0');
dac0_tlast <= '0'; 

-------------------------------------------------------------------------
-- AXI-Lite Traffic Generator
---------------------------------------------------------------------------  
--inst_traffic_gen: 
--axi_traffic_gen_4
--PORT MAP (
--  s_axi_aclk             => axi_aclk,
--  s_axi_aresetn          => axi_aresetn,
--  m_axi_lite_ch1_awaddr  => axi_awaddr,
--  m_axi_lite_ch1_awprot  => open,
--  m_axi_lite_ch1_awvalid => axi_awvalid,
--  m_axi_lite_ch1_awready => axi_awready,
--  m_axi_lite_ch1_wdata   => axi_wdata,
--  m_axi_lite_ch1_wstrb   => axi_wstrb,
--  m_axi_lite_ch1_wvalid  => axi_wvalid,
--  m_axi_lite_ch1_wready  => axi_wready,
--  m_axi_lite_ch1_bresp   => axi_bresp,
--  m_axi_lite_ch1_bvalid  => axi_bvalid,
--  m_axi_lite_ch1_bready  => axi_bready,
--  m_axi_lite_ch1_araddr  => axi_araddr,
--  m_axi_lite_ch1_arvalid => axi_arvalid,
--  m_axi_lite_ch1_arready => axi_arready,
--  m_axi_lite_ch1_rdata   => axi_rdata,
--  m_axi_lite_ch1_rvalid  => axi_rvalid,
--  m_axi_lite_ch1_rresp   => axi_rresp,
--  m_axi_lite_ch1_rready  => axi_rready,
--  done                   => done,
--  status                 => status
--);

inst0_jtag_axi: jtag_axi_0
  PORT MAP (
    aclk          => axi_aclk,
    aresetn       => axi_aresetn,
    m_axi_awaddr  => axi_awaddr,
    m_axi_awprot  => open,--axi_awprot,
    m_axi_awvalid => axi_awvalid,
    m_axi_awready => axi_awready,
    m_axi_wdata   => axi_wdata,
    m_axi_wstrb   => axi_wstrb,
    m_axi_wvalid  => axi_wvalid,
    m_axi_wready  => axi_wready,
    m_axi_bresp   => axi_bresp,
    m_axi_bvalid  => axi_bvalid,
    m_axi_bready  => axi_bready,
    m_axi_araddr  => axi_araddr,
    m_axi_arprot  => open, --axi_arprot,
    m_axi_arvalid => axi_arvalid,
    m_axi_arready => axi_arready,
    m_axi_rdata   => axi_rdata,
    m_axi_rresp   => axi_rresp,
    m_axi_rvalid  => axi_rvalid,
    m_axi_rready  => axi_rready
  );
--***********************************************************************************
end architecture Behavioral;
--***********************************************************************************

